var MODULE_NAME  = "Goto label";
var MODULE_VER   = "1.0";
var MODULE_TITLE = "Jumps to the label.";

var ed;

function Init() {
    menuName = "&" + MODULE_NAME;
    subMenu = "&" + "DMIS";
    addMenuItem(menuName, subMenu, "main", "CTRL+SHIFT+L");
}


function main() 
{
	 ed = newEditor();
	 ed.assignActiveEditor();
	
	 saveBeforeJumpPos( ed );

	 var selLabel = ed.selText();
	 var foundLabel = selLabel;

    var currPosY = ed.caretY();
    var currFileName = ed.fileName();
    var fso = new ActiveXObject( "Scripting.FileSystemObject" );
    var fs = fso.OpenTextFile( currFileName, 1, false );
    var alltext = fs.ReadAll();
    fs.Close();
    var splitlines = alltext.split( '\n' );

    
    var loopPos = currPosY -1;
    var macroBeginPos = 1;
    macroBeginLoop :
	 while( loopPos > 0 )
	 {
	     var loopline = splitlines[loopPos];
	     if ( loopline.search( /^MACRO/i ) != -1 )
	     {
	        macroBeginPos = loopPos;
		  	  break macroBeginLoop;
		  }
		  loopPos--;
	 }
	 
	 var ypos = macroBeginPos+1;
	 var regexplabel = new RegExp( "^[ \t]*[\(]{1}(" + selLabel + ")[\)]{1}" );  

	 labelloop : 
	 while( ypos < splitlines.length )
	 {
	     var actline = splitlines[ypos];
	     if ( actline.search( /^ENDMAC/i ) != -1 )
	     {
		      echo( 'Specified label not found !' );
		      return false;
		  }
		  if ( actline.search( regexplabel ) != -1 )
		  {
		      foundLabel = ypos +1;
		  	   break labelloop;
		  }
		  ypos ++;
	 }
	 
	 ed.setCaretPos( 0, foundLabel );

	 return 1;
}




























function saveBeforeJumpPos( activeEditor )
{
    var activeFileName = activeEditor.fileName();
    var carx = activeEditor.caretX();
    var cary = activeEditor.caretY();
    var fso = new ActiveXObject("Scripting.FileSystemObject");
    var fs = fso.OpenTextFile( '../savedpos.txt', 8, true );
    fs.WriteLine( activeFileName + ',' + carx + ',' + cary );
    fs.Close();
}
